byhand-task 1.7 KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950515253545556575859606162636465666768697071727374
  1. #!/bin/bash
  2. set -u
  3. set -e
  4. set -o pipefail
  5. if [ $# -lt 4 ]; then
  6. echo "Usage: $0 filename version arch changes_file"
  7. exit 1
  8. fi
  9. export SCRIPTVARS=/srv/ftp-master.debian.org/dak/config/debian/vars
  10. . $SCRIPTVARS
  11. INPUT="$1" # Tarball to read, compressed with gzip
  12. VERSION="$2"
  13. ARCH="$3"
  14. CHANGES="$4" # Changes file for the upload
  15. error() {
  16. echo "$*"
  17. exit 1
  18. }
  19. # Get the target suite from the Changes file
  20. # NOTE: it may be better to pass this to the script as a parameter!
  21. SUITE="$(grep "^Distribution:" "$CHANGES" | awk '{print $2}')"
  22. case $SUITE in
  23. "")
  24. error "Error: unable to determine suite from Changes file"
  25. ;;
  26. unstable|sid)
  27. : # OK for automated byband processing
  28. ;;
  29. *)
  30. error "Reject: task overrides can only be processed automatically for uploads to unstable"
  31. ;;
  32. esac
  33. # Regular expression used to validate tag lines
  34. CHECKRE='^[a-z0-9A-Z.+-]+[[:space:]]+Task[[:space:]]+[a-z0-9:. ,{}+-]+$'
  35. # This must end with /
  36. TARGET=/srv/ftp-master.debian.org/scripts/external-overrides/
  37. # Read the main directory from the tarball
  38. DIR="`tar ztf \"$INPUT\" | tac | tail -n 1`"
  39. # Create temporary files where to store the validated data
  40. umask 002
  41. OUTMAIN="`mktemp \"$TARGET\"task.new.XXXXXX`"
  42. # If we fail somewhere, cleanup the temporary files
  43. cleanup() {
  44. rm -f "$OUTMAIN"
  45. }
  46. trap cleanup EXIT
  47. # Extract the data into the temporary files
  48. tar -O -zxf "$INPUT" "$DIR"task | grep -E "$CHECKRE" > "$OUTMAIN"
  49. # Move the data to the final location
  50. mv "$OUTMAIN" "$TARGET"task
  51. chmod 644 "$TARGET"task
  52. dak external-overrides import unstable main Task <"$TARGET"task
  53. dak external-overrides copy unstable testing
  54. trap - EXIT
  55. exit 0